#include "Form1.frm"

/*
 * Evento OnShow.
 */
METHOD Form1OnShow( oSender ) CLASS TForm1

   DbUseArea( .T., "DbfNtx", "Test.dbf", "Test1", .T., .F. )
   Test1->( OrdCreate( "Test1.ntx", "Nombre", "Upper( First + Last )", ;
                               { || Upper( Field->First + Field->Last ) }, .F. ) )
   Test1->( OrdCreate( "Test2.ntx", "Apellidos", "Upper( Last + First )", ;
                               { || Upper( Field->Last + Field->First ) }, .F. ) )
INDEX ON Field->SALARY to Test3

   Test1->( OrdListClear() )
   Test1->( OrdListAdd( "Test1" ) )
   Test1->( OrdListAdd( "Test2" ) )
Test1->( OrdListAdd( "Test3" ) )
Test1->( DbSetOrder(3) )
Test1->( DbGoTop() )

   DbUseArea( .T., "DbfNtx", "Test.dbf", "Test2", .T., .F. )
   ::oGrid1:SetFocus()

return

/*
 * Evento OnCloseQuery.
 */
METHOD Form1OnCloseQuery( oSender, lCanClose ) CLASS TForm1

   

return

/*
 * Evento OnClick.
 */
METHOD SpeedButton1OnClick( oSender ) CLASS TForm1

   Test1->( OrdSetFocus( 1 ) )
   Test1->( DbGoTop() )
   ::oGrid1:Refresh()

return

/*
 * Evento OnClick.
 */
METHOD SpeedButton2OnClick( oSender ) CLASS TForm1

   Test1->( OrdSetFocus( 2 ) )
   Test1->( DbGoTop() )
   ::oGrid1:Refresh()

return

/*
 * Evento OnCreate.
 */
METHOD Form1OnCreate( oSender ) CLASS TForm1

   ::oGrid1 := TDbGrid():Create( Self )
   ::oGrid1:SetBounds( 8, 26, 400, 150 )
   ::oGrid1:Alias := "Test1"
   ::oGrid1:Header := { "Nombre", "Apellido", "Salary" } //"Direccin" }
   ::oGrid1:Sizes := { 100, 100, 130 }
   ::oGrid1:Fields := { "First", "Last", "Salary" } //"Street" }
   ::oGrid1:Alignments := { taLeftJustify, taLeftJustify, taRightJustify } //taCenter }
   ::oGrid1:RowSelect := .T.
   ::oGrid1:HeaderImageList:Images := { "Head", "Index1", "Index2" }
   ::oGrid1:OnDblClick := { || MessageDlg( "Seleccionado: " + RTrim( Test1->First - ;
                                           ( " " + Test1->Last ) ), mtInformation, mbOk, poActiveCenter ) }
   ::oGrid1:OnDrawCell := { | oSender, nRow, nCol, nTextColor, nBkColor | nBkColor :=  If( nRow % 2 == 0, clWhite, clInfoBk ) }
   ::oGrid1:OnSearch := { | oSender, cBuffer | Test1->( DbSeek( Upper( cBuffer ) ) ) }

   ::oGrid2 := TDbGrid():Create( Self )
   ::oGrid2:SetBounds( 8, 210, 400, 150 )
   ::oGrid2:Alias := "Test2"
   ::oGrid2:Header := { "Nombre", "Apellido", "Direccin" }
   ::oGrid2:Sizes := { 100, 100, 130 }
   ::oGrid2:Fields := { "First", "Last", "Street" }
   ::oGrid2:Alignments := { taLeftJustify, taLeftJustify, taCenter }
   ::oGrid2:RowSelect := .T.
   ::oGrid2:HeaderImageList:Images := { "Head", "Index1", "Index2" }
   ::oGrid2:OnDblClick := { || MessageDlg( "Seleccionado: " + RTrim( Test2->First - ;
                                           ( " " + Test2->Last ) ), mtInformation, mbOk, poActiveCenter ) }
   ::oGrid2:OnDrawCell := { | oSender, nRow, nCol, nTextColor, nBkColor | nBkColor :=  If( nRow % 2 == 0, clWhite, clInfoBk ) }

return

/*
 * Evento OnClick.
 */
METHOD Button1OnClick( oSender ) CLASS TForm1

   ::Close()

return

/*
 * Evento OnTimer.
 */
METHOD Timer1OnTimer( oSender ) CLASS TForm1

   ::Label3:Caption := Time()

return